using System.Text.Json.Serialization;

namespace Adaptation.FileHandlers.json.WorkItems;

internal class Attribute
{

#nullable enable

    [JsonConstructor]
    public Attribute(bool isLocked,
                     string name,
                     string? parameterTitle,
                     string? state,
                     string? workItemType)
    {
        IsLocked = isLocked;
        Name = name;
        ParameterTitle = parameterTitle;
        State = state;
        WorkItemType = workItemType;
    }

    [JsonPropertyName("isLocked")] public bool IsLocked { get; }
    [JsonPropertyName("name")] public string Name { get; }
    [JsonPropertyName("parameterTitle")] public string? ParameterTitle { get; set; }
    [JsonPropertyName("state")] public string? State { get; set; }
    [JsonPropertyName("workItemType")] public string? WorkItemType { get; set; }

}

[JsonSourceGenerationOptions(WriteIndented = true)]
[JsonSerializable(typeof(Attribute))]
internal partial class AttributeSourceGenerationContext : JsonSerializerContext
{
}