using System.Text.Json.Serialization;

namespace Adaptation.FileHandlers.json.WorkItems;

internal class Value
{

    [JsonConstructor]
    public Value(
        int id,
        int rev,
        Fields fields,
        WIQL.Relation[] relations,
        CommentVersionRef commentVersionRef,
        string url
    )
    {
        Id = id;
        Rev = rev;
        Fields = fields;
        Relations = relations;
        CommentVersionRef = commentVersionRef;
        Url = url;
    }

    [JsonPropertyName("commentVersionRef")] public CommentVersionRef CommentVersionRef { get; }
    [JsonPropertyName("fields")] public Fields Fields { get; }
    [JsonPropertyName("id")] public int Id { get; }
    [JsonPropertyName("relations")] public WIQL.Relation[] Relations { get; }
    [JsonPropertyName("rev")] public int Rev { get; }
    [JsonPropertyName("url")] public string Url { get; }

}

[JsonSourceGenerationOptions(WriteIndented = true)]
[JsonSerializable(typeof(Value))]
internal partial class ValueSourceGenerationContext : JsonSerializerContext
{
}